<?php
if(get_option('dsv_telephone_validation')){
    add_action('elementor_pro/forms/validation/tel', 'validate_telephone_datasoap_number_ep', 10, 3);
}

function validate_telephone_datasoap_number_ep($field, $record, $ajax_handler ){
	$value = $field['value'];
	if($value == null){
		return;
	}
	
	$number = sanitize_text_field($field['value']);

	$dsv_token = get_option('dsv_token');

	if($dsv_token != ""){
		$params = array(
			'lookup' => $number,
			'checks' => array (
				'Auto'
			)
		);
	
		$apiResult = sendDataSoapValidationRequest($params, $dsv_token);
	
		if(!isset($apiResult['valid'])){
			$ajax_handler->add_error( $field['id'], 'Please enter a valid phone number' );
			return;
		}

		if ($apiResult['valid'] == false || $apiResult['valid'] == true && isset($apiResult['errors']))
			$ajax_handler->add_error( $field['id'], 'Please enter a valid phone number' );
	}
	else{
		$params = array(
			'lookup' => $number,
			'checks' => array (
				'Syntax'
			)
		);

		$apiResult = sendDataSoapValidationRequest($params, "");

		if(!isset($apiResult['valid'])){
			$ajax_handler->add_error( $field['id'], 'Please enter a valid phone number' );
			return;
		}

		if ($apiResult['valid'] == false && !isset($apiResult['errors']))
			$ajax_handler->add_error( $field['id'], 'Please enter a valid phone number' );
	}

	return;
}


if(get_option('dsv_email_validation')){
    add_action('elementor_pro/forms/validation', 'validate_email_address_datasoap_ep', 10, 2);
}

function validate_email_address_datasoap_ep($record, $ajax_handler ){
	$fields = $record->get_field([]);
	foreach($fields as $field){
		$fieldId = $field['id'];
		if(strpos($fieldId, "ds_emailval") !== false){
			$email = sanitize_email($field['value']);

			if($email == ""){
				continue;
			}

			$dsv_token = get_option('dsv_token');

			if($dsv_token != ""){

				$params = array(
					'lookup' => $email,
					'checks' => array (
						'Email'
					)
				);
				
				$apiResult = sendDataSoapValidationRequest($params, $dsv_token);
				
				if(!isset($apiResult['valid'])){
					$ajax_handler->add_error( $field['id'], 'Please enter a valid email address' );
					return;
				}

				if ($apiResult['valid'] == false)
					 $ajax_handler->add_error( $field['id'], 'Please enter a valid email address' );
			}
			else{
				$params = array(
					'lookup' => $email,
					'checks' => array (
						'Syntax'
					)
				);
		
				$apiResult = sendDataSoapValidationRequest($params, "");

				if(!isset($apiResult['valid'])){
					$ajax_handler->add_error( $field['id'], 'Please enter a valid email address' );
					return;
				}

				if ($apiResult['valid'] == false)
					$ajax_handler->add_error( $field['id'], 'Please enter a valid email address' );
			}
		}
	}
	return;
}

?>