<?php

if (get_option('dsv_telephone_validation')) 
	add_filter( 'gform_field_validation', 'validate_telephone_datasoap_gf', 10, 4 );

function validate_telephone_datasoap_gf( $result, $value, $form, $field ) {
	$current_page = rgpost( 'gform_source_page_number_' . $form['id'] ) ? rgpost( 'gform_source_page_number_' . $form['id'] ) : 1;
	if ( $field->get_input_type() === 'phone' && $result['is_valid'] && $value != '' && $field->pageNumber == $current_page) {
		
		$params = array(
			'lookup' => $value,
			'checks' => array (
				'Auto'
			)
		);
		
		$dsv_token = get_option('dsv_token');

		if($dsv_token != "") {
			$apiResult = sendDataSoapValidationRequest($params, $dsv_token);
		
			if(!isset($apiResult['valid'])){
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid phone number";
				return $result;
			}

			if ($apiResult['valid'] == false || $apiResult['valid'] == true && isset($apiResult['errors'])) {
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid phone number";
			}
		}
		else{
			$params = array(
				'lookup' => $value,
				'checks' => array (
					'Syntax'
				)
			);
	
			$apiResult = sendDataSoapValidationRequest($params, "");

			if(!isset($apiResult['valid'])){
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid phone number";
				return $result;
			}

			if ($apiResult['valid'] == false && !isset($apiResult['errors']))
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid phone number";
		}
	}
	return $result;
}
	
if (get_option('dsv_email_validation'))
	add_filter( 'gform_field_validation', 'validate_email_address_datasoap_gf', 10, 4 );

function validate_email_address_datasoap_gf( $result, $value, $form, $field ) {
	$current_page = rgpost( 'gform_source_page_number_' . $form['id'] ) ? rgpost( 'gform_source_page_number_' . $form['id'] ) : 1;
	if ( $field->get_input_type() === 'email' && $result['is_valid'] && $value != '' && $field->pageNumber == $current_page) {

		$params = array(
			'lookup' => $value,
			'checks' => array (
				'Email'
			)
		);
		
		$dsv_token = get_option('dsv_token');

		if($dsv_token != "") {
			$apiResult = sendDataSoapValidationRequest($params, $dsv_token);
		
			if(!isset($apiResult['valid'])){
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid email address";
				return $result;
			}

			if ($apiResult['valid'] == false) {
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid email address";
			}
		}
		else{
			$params = array(
				'lookup' => $value,
				'checks' => array (
					'Syntax'
				)
			);
	
			$apiResult = sendDataSoapValidationRequest($params, "");

			if(!isset($apiResult['valid'])){
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid email address";
				return $result;
			}

			if ($apiResult['valid'] == false) {
				$result['is_valid'] = false;
				$result['message'] = "Please enter a valid email address";
		}
	}

	return $result;
	}
}
?>