<?php

add_action('woocommerce_checkout_process', 'dsvwc_validate');

function dsvwc_validate(){

	// telephone validation
	if(get_option('dsv_telephone_validation'))
		validate_telephone_datasoap_number_wc('billing_phone');

	// email validation
	if(get_option('dsv_email_validation'))
		validate_email_address_datasoap_wc('billing_email');
}

function validate_telephone_datasoap_number_wc($name) {
	$sanitisedNumber = '';
	
	if(isset($_POST[$name])){
		$sanitisedNumber = sanitize_text_field($_POST[$name]);
	}

	$number = $sanitisedNumber;

	if ('' == $number) 
		return;
	elseif ( '' != $number) {
		$dsv_token = get_option('dsv_token');

		if($dsv_token != "")
		{
			$params = array(
				'lookup' => $number,
				'checks' => array (
					'Auto'
				)
			);

			$apiResult = sendDataSoapValidationRequest($params, $dsv_token);

			if(!isset($apiResult['valid'])){
				wc_add_notice(__('Please enter a valid phone number'), 'error' );
				return;
			}

			if ($apiResult['valid'] == false || $apiResult['valid'] == true && isset($apiResult['errors']))
				wc_add_notice(__('Please enter a valid phone number'), 'error' );
		}
		else{
			$params = array(
				'lookup' => $number,
				'checks' => array (
					'Syntax'
				)
			);

			$apiResult = sendDataSoapValidationRequest($params, "");

			if(!isset($apiResult['valid'])){
				wc_add_notice(__('Please enter a valid phone number'), 'error' );
				return;
			}

			if ($apiResult['valid'] == false && !isset($apiResult['errors']))
				wc_add_notice(__('Please enter a valid phone number'), 'error' );
		}
	}
}

function validate_email_address_datasoap_wc($name) {
	$sanitisedEmail = '';
	
	if(isset($_POST[$name])){
		$sanitisedEmail = sanitize_email($_POST[$name]);
	}

	$email = $sanitisedEmail;

	if ('' == $email)
		return;

	$dsv_token = get_option('dsv_token');
		
	if($dsv_token != "")
	{
		$params = array(
			'lookup' => $email,
			'checks' => array (
				'Email'
			)
		);

		$apiResult = sendDataSoapValidationRequest($params, $dsv_token);

		if(!isset($apiResult['valid'])){
			wc_add_notice(__('Please enter a valid email address'), 'error' );
			return;
		}

		if ($apiResult['valid'] == false)
			wc_add_notice(__('Please enter a valid email address'), 'error' );
	}
	else{
		$params = array(
			'lookup' => $email,
			'checks' => array (
				'Syntax'
			)
		);

		$apiResult = sendDataSoapValidationRequest($params, "");

		if(!isset($apiResult['valid'])){
			wc_add_notice(__('Please enter a valid email address'), 'error' );
			return;
		}

		if ($apiResult['valid'] == false)
			wc_add_notice(__('Please enter a valid email address'), 'error' );
	}
}

?>