<?php

if (get_option('dsv_telephone_validation')){
	add_action( 'wpforms_process_validate_phone', 'validate_telephone_datasoap_number_wpf', 10, 3 );
}

function validate_telephone_datasoap_number_wpf( $field_id, $field_submit, $form_data ) {
	$number = $field_submit;
	if($field_submit == null){
		return;
	}

	$number = sanitize_text_field($field_submit);
	$dsv_token = get_option('dsv_token');

	if($dsv_token != ""){
		$params = array(
			'lookup' => $number,
			'checks' => array (
				'Auto'
			)
		);
	
		
		$apiResult = sendDataSoapValidationRequest($params, $dsv_token);
	
		if(!isset($apiResult['valid'])){
			wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
			wpforms()->process->errors[ $form_data['id'] ] [$field_id] = esc_html__('Please enter a valid phone number', 'plugin-domain');
			return;
		}

		if ($apiResult['valid'] == false || $apiResult['valid'] == true && isset($apiResult['errors'])) {
			wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
			wpforms()->process->errors[ $form_data['id'] ] [$field_id] = esc_html__('Please enter a valid phone number', 'plugin-domain');
		} 
	}
	else{
		$params = array(
			'lookup' => $number,
			'checks' => array (
				'Syntax'
			)
		);

		$apiResult = sendDataSoapValidationRequest($params, "");

		if(!isset($apiResult['valid'])){
			wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
			wpforms()->process->errors[ $form_data['id'] ] [$field_id] = esc_html__('Please enter a valid phone number', 'plugin-domain');
			return;
		}

		if ($apiResult['valid'] == false && !isset($apiResult['errors']))
			wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
			wpforms()->process->errors[ $form_data['id'] ] [$field_id] = esc_html__('Please enter a valid phone number', 'plugin-domain');
	}
}

if (get_option('dsv_email_validation')){
	add_action( 'wpforms_process', 'validate_email_address_datasoap_wpf', 10, 3 );
}

function validate_email_address_datasoap_wpf( $fields, $entry, $form_data ) {
	$email = "";
	$dsv_token = get_option('dsv_token');

    //check fields for email
	foreach ( $fields as $field_id => $field ) {
		//if field type is email run validation logic
        if($field['type'] == "email"){
			$email = sanitize_email($field['value']);
			$emailId = sanitize_text_field($field['id']);

			//return if email blank, setting field to required can be done in WPForms
			if($email == ""){
				continue;
			}

			if($dsv_token != ""){
				$params = array(
					'lookup' => $email,
					'checks' => array (
						'Email'
					)
				);
				
				$apiResult = sendDataSoapValidationRequest($params, $dsv_token);
	
				if(!isset($apiResult['valid'])){
					wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
					wpforms()->process->errors[ $form_data['id'] ] [$emailId] = esc_html__('Please enter a valid email address', 'plugin-domain');
					return;
				}

				if ($apiResult['valid'] == false){
					wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
					wpforms()->process->errors[ $form_data['id'] ] [$emailId] = esc_html__('Please enter a valid email address', 'plugin-domain');
				}
			}
			else{
				$params = array(
					'lookup' => $email,
					'checks' => array (
						'Syntax'
					)
				);
		
				$apiResult = sendDataSoapValidationRequest($params, "");
		
				if(!isset($apiResult['valid'])){
					wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
					wpforms()->process->errors[ $form_data['id'] ] [$emailId] = esc_html__('Please enter a valid email address', 'plugin-domain');
					return;
				}

				if ($apiResult['valid'] == false)
					wpforms()->process->errors[ $form_data['id']]['header'] = esc_html__( 'Some details invalid', 'plugin-domain' );
					wpforms()->process->errors[ $form_data['id'] ] [$emailId] = esc_html__('Please enter a valid email address', 'plugin-domain');
			}
		} 	
    }
}

?>